library(factoextra)
library(openxlsx)
library(readxl)
#source("kmeansGeneral.R")

#specify the number of clusters expected to get
GL_k <- 5;#k=4 with "ward.D" hie initial
GL_nindex <- 18;#number of indices/variables in dataset
GL_nobs <- 33;#number of observations/cities
GL_ntp <- 15;#number of time points


GL_weightt <- readRDS("/Users/siyan/Desktop/Supplementary material/Part III/R software code/weighttms.RDS");



GL_myData<-readRDS("/Users/siyan/Desktop/Supplementary material/Part III/R software code/datasmnew830.Rds");#lpsm  

#data pre-process:
#normalize by min and max to 0-1
source("/Users/siyan/Desktop/Supplementary material/Part III/R software code/datapre.R");                               
GL_myDatanew<-array(dim=c(GL_ntp,GL_nindex,GL_nobs))
for (v in 1:GL_nindex)
{
  for (j in 1:GL_ntp)
  {
    GL_myDatanew[j,v,] <- min.max.norm(GL_myData[j,v,])
  }
}
GL_myData <- GL_myDatanew;

source("/Users/siyan/Desktop/Supplementary material/Part III/R software code/calewm.R"); 
#entropy weights
GL_weightv <- c(calewm(GL_myData[,1:6,]),calewm(GL_myData[,6+(1:7),]),
                calewm(GL_myData[,6+7+(1:5),]));
GL_weightv
source("/Users/siyan/Desktop/Supplementary material/Part III/R software code/citydis.R");
#choose distance
GL_disType <- 3;#L2-type

source("/Users/siyan/Desktop/Supplementary material/Part III/R software code/initialkmeans-hier.R");
aggmethod <- "ward.D"#"ward.D"#"ward.D2"#"ward.D";##
#ward.D", "ward.D2", "single", "complete", "average" (= UPGMA), "mcquitty" (= WPGMA), "median" (= WPGMC) or "centroid" (= UPGMC).
#minimax
hresult<-inithier(GL_k,GL_disType,aggmethod);
citylist<-as.matrix(c(1:33))

city_name <- as.matrix(read.xlsx('/Users/siyan/Desktop/Supplementary material/Part III/R software code/originaldata.xlsx','city'))[,1];
citycluster<-c(city_name[citylist[1,]],city_name[citylist[2,]],city_name[citylist[3,]],
               city_name[citylist[4,]],city_name[citylist[5,]],city_name[citylist[6,]],
               city_name[citylist[7,]],city_name[citylist[8,]],city_name[citylist[9,]],
               city_name[citylist[10,]],city_name[citylist[11,]],city_name[citylist[12,]],
               city_name[citylist[13,]],city_name[citylist[14,]],city_name[citylist[15,]],
               city_name[citylist[16,]],city_name[citylist[17,]],city_name[citylist[18,]],
               city_name[citylist[19,]],city_name[citylist[20,]],city_name[citylist[21,]],
               city_name[citylist[22,]],city_name[citylist[23,]],city_name[citylist[24,]],
               city_name[citylist[25,]],city_name[citylist[26,]],city_name[citylist[27,]],
               city_name[citylist[28,]],city_name[citylist[29,]],city_name[citylist[30,]],
               city_name[citylist[31,]],city_name[citylist[32,]],city_name[citylist[33,]])
hresult$labels<-citycluster
plot(hresult,hang=-1);
#whether use cuttree to determine clusters automatically
CT <- TRUE;
#CT <- FALSE;
if(CT)#use cuttree
{
  if(aggmethod!="minimax") {GL_initcls <- cutree(hresult,GL_k);}
  else {GL_initcls <- protocut(hresult, GL_k)$cl;}                 
}
print(GL_initcls);print(table(GL_initcls));
rcls <- GL_initcls;
fviz_dend(hresult, k = 5, 
          cex = 1, 
          k_colors = c("#2E9FDF", "#00AFBB", "#E7B800", "#FC4E07","purple"),
          color_labels_by_k = TRUE, 
          rect = TRUE          
)

fviz_dend(hresult,k=5,rect =T,rect_fill = T,type = "circular",
          rect_border = c("#2E9FDF", "#00AFBB", "#E7B800", "#FC4E07","purple"))



for(i in 1:GL_k)
{
  print(city_name[which(rcls==i)]);
  print("========");
}





