#global vars: nindex, weightt,weightv,newSDs,myData
calCenter <- function(ic,clusterInd,disType,centerType)
{
  clsIndsel <- (clusterInd==ic);
  clsInd <- (1:GL_nobs)[clsIndsel];
  if(sum(clsIndsel)>1)
  {
    if(centerType==1){ # k means method
      for (v in 1:GL_nindex)
      {
        datacv <- GL_myData[,v,clsIndsel];
        GL_newMeans[,v,ic] <<- apply(datacv,1,mean) # calculate the updated k means
        GL_newSDs[,v,ic] <<- apply(datacv,1,sd) # calculate the updated k sds
      }#end of for v
    }else if(centerType==2){ # k medoids method
      for (v in 1:GL_nindex)
      {
        datacv <- GL_myData[,v,clsIndsel];
        GL_newSDs[,v,ic] <<- apply(datacv,1,sd); # calculate the updated k sds
      }#end of for v
      clsnum <- length(clsInd);
      #calculate distance matrix
      dmat <- matrix(0,clsnum,clsnum);
      for(i in 1:(clsnum-1))
      {
        clsi <- clsInd[i];
        for(j in (i+1):clsnum)
        {
          clsj<-clsInd[j];
          dmat[i,j] <- calDisObs(clsi,clsj,GL_weightt,GL_weightv,GL_disType,GL_newSDs[,,ic]);
          dmat[j,i] <- dmat[i,j];
        }#end of for j
      }#end of for i
      dis2others <- colSums(dmat);
      centerID <- clsInd[which.min(dis2others)];print(clsInd);print(dmat);print(GL_newSDs);
      GL_newMeans[,,ic] <<- GL_myData[,,centerID]; # calculate the updated k centroids
    }else if(centerType==3){ # k medoids revised method, find center for each index
      clsnum <- length(clsInd);
      #calculate distance array for each index
      dmat <- array(data=0,dim=c(clsnum,clsnum,GL_nindex))
      dis2others <- matrix(,GL_nindex,clsnum)
      centerID <- rep(0,GL_nindex);
      for (v in 1:GL_nindex)
      {
        datacv <- GL_myData[,v,clsIndsel];
        GL_newSDs[,v,ic] <<- apply(datacv,1,sd); # calculate the updated k sds
        for(i in 1:(clsnum-1))
        {
          clsi <- clsInd[i];
          for(j in (i+1):clsnum)
          {
            clsj<-clsInd[j];
            dmat[i,j,v] <- calDisObs_index(clsi,clsj,GL_weightt,v,GL_disType,GL_newSDs[,,ic]);
            dmat[j,i,v] <- dmat[i,j,v];
          }#end of for j
        }#end of for i
        dis2others[v,] <- colSums(dmat[,,v]);#print(clsInd);
        centerID[v] <- clsInd[which.min(dis2others[v,])];#print(clsInd);print(dmat);print(newSDs);
        GL_newMeans[,v,ic] <<- GL_myData[,v,centerID[v]]; # calculate the updated k centroids
      }#end of for v
    }
  }else if(sum(clsIndsel)==1)
  {
    for (v in 1:GL_nindex)
    {
      datacv <- GL_myData[,v,clsIndsel];
      GL_newMeans[,v,ic] <<- datacv; # calculate the updated k means
      #newSDs[,v,ic] <<- apply(datacv,1,sd) # calculate the updated k sds      
    }#end of for v
  }#end of else if(sum(clsIndsel)==1)
}#end of function