#  myData<-array(dim=c(ntp,nindex,nobs))
# calculate the entropy weight for data
calewm <- function(myData){
  ntp<-dim(myData)[1]
  nindex<-dim(myData)[2]
  nobs<-dim(myData)[3]
  p<-array(dim=c(ntp,nindex,nobs))
  temp<-array(dim=c(ntp,nindex,nobs))
  # calculate the denominator of the weight function p
  sumobs<-apply(myData,c(1,2),sum) # dim: ntp*nindex
  for (j in 1:nobs)
  {
    # p[,v,j] is the jth obs's weight function of the vth index 
    p[,,j]<-myData[,,j]/sumobs;
    temp[,,j]<-plogp(p[,,j]);#temp[,,j]<-p[,,j]*log(p[,,j]);
  }
  
  e1<-apply(temp,c(1,2),sum)#sum over all obs
    # e is the entropy value of the vth index 
  e<--1/log(nobs)*apply(e1,2,sum)/ntp#integrate over all time points
  # w is the entropy weight of the vth index
  w<-(1-e)/sum(1-e)
  return(w)
}

#convention: 0*log(0)=0 in the definition of entropy
plogp <- function(p)
{
  ifelse(p==0,0,p*log(p));
  #if(p==0) {return (0)};
  #else {return (p*log(p))};
}

##example:
#array1 <- array(c(-5.5,6,3),dim = c(3,4,2));array1
#weight<-calewm(array1)



