# calculate the initial 18 standard deviations
GL_poolSDs <- matrix(0,15,GL_nindex)
for (v in 1:GL_nindex)
{
  vari <- GL_myData[,v,];
  GL_poolSDs[,v] <- apply(vari,1,sd) # calculate the initial 18 standard deviations
}

# #calculate distance between two observations, using the pooled SDs
# calDisObs <- function(obs_i,obs_j,weightt,weightv,type=disType,sds=poolSDs){
#   obsi <- myData[,,obs_i];
#   obsj <- myData[,,obs_j];
#   dis <- 0;
#   for (v in 1:nindex)
#   {
#     if(type==1)
#     {
#       tmpdis <- sum(weightt*(obsi[,v]-obsj[,v])^2)/sum((sds[,v])^2); 
#     }else if(type==2)
#     {
#       tmpdis <- sum(weightt*((obsi[,v]-obsj[,v])/sds[,v])^2);
#     }else{
#       tmpdis <- sum(weightt*(obsi[,v]-obsj[,v])^2);
#     }
#     dis <- dis+weightv[v]*tmpdis;
#   }
#   return(dis);
# }

#calculate distance between two observations, using the pooled SDs
calDisObs <- function(obs_i,obs_j,weightt,weightv,type=GL_disType,sds=GL_poolSDs){
  obsi <- GL_myData[,,obs_i];
  obsj <- GL_myData[,,obs_j];
  dis <- 0;
  for (v in 1:GL_nindex)
  {
    tmpdis <- calDisObs_index(obs_i,obs_j,weightt,index=v,type,sds);
    dis <- dis+weightv[v]*tmpdis;
  }
  return(dis);
}
#calculate distance between two observations's index
calDisObs_index <- function(obs_i,obs_j,weightt,index,type=GL_disType,sds=GL_poolSDs){
  obsi <- GL_myData[,,obs_i];
  obsj <- GL_myData[,,obs_j];
  if(type==1)#F-type
  {
    dis <- sum(weightt*(obsi[,index]-obsj[,index])^2)/sum((sds[,index])^2); 
  }else if(type==2)#GPF-type
  {
    dis <- sum(weightt*((obsi[,index]-obsj[,index])/sds[,index])^2);
  }else{#L2-type
    dis <- sum(weightt*(obsi[,index]-obsj[,index])^2);
  }
  return(dis);
}