#https://en.wikipedia.org/wiki/K-means_clustering

#(1)define global variables: GL_oldMeans, GL_newMeans, GL_dataObs,

#(2)define the following functions

#give an initial set of k means
initkmeans <- function(k){
  #GL_newMeans <<-
}

#calculate the distance between the i-th observation and the j-th mean
calDis <- function(obs_i,mean_j){
  return(0);
}

#calculate / update the means
updateMeans <- function(clusterInd,n,k){
  #GL_oldMeans <<- GL_newMeans;
  #GL_newMeans <<- ...
}

#calculate diff between oldMean and newMean
calMeanDiff <- function(){
  return(0);
}

#optional
#calculate the within-point scatter (value of the objective function to be minized)
calWPS <- function(clusterInd,n,k){
  return(0);
}

kmeansGeneral <- function(n,k,epsilon=0.001)
{
  initkmeans(k);
  repeat
  { 
    #Assignment step
    clusterInd <- rep(0,n);
    for(i in 1:n)
    {
      #calculate distances of the i-th obs to the k means
      dis2means <- rep(0,k);
      for(j in 1:k)
      { #dis between ith obs and jth mean
        dis2means[j] <- calDis(i,j);
      }
      clusterInd[i] <- which.min(dis2means);
    }
    print(paste("kmeans update:",paste(clusterInd,sep='',collapse='')));
    
    #Update step
    updateMeans(clusterInd,n,k);
    
    #calculate the WPS
    clusterCnt <- rep(0,k);
    sumdis2means <- rep(0,k);
    for(i in 1:n)
    {
      clsInd_i <- clusterInd[i];
      sumdis2means[clsInd_i] <- sumdis2means[clsInd_i]+calDis(i,clsInd_i);
      clusterCnt[clsInd_i] <- clusterCnt[clsInd_i]+1;
    }
    WPS <- sum(sumdis2means*clusterCnt);
    print(paste("mean diff:",calMeanDiff()));
    print(paste("WPS:",WPS));
    #print(paste("calWPS():",calWPS(clusterInd,n,k)));
    if(calMeanDiff()<epsilon){break;}
  }
  return(clusterInd);
}

#RUN_EXAMPLE=FALSE;
RUN_EXAMPLE=TRUE;
if(RUN_EXAMPLE)
{
  GL_k <- 2;
  GL_oldMeans <- rep(0,GL_k);
  GL_newMeans <- rep(0,GL_k);
  GL_dataObs <- c(rnorm(50),rnorm(50)+4);
  
  #give an initial set of k means
  initkmeans <- function(k){
    GL_newMeans <<- rnorm(k);#use "<<-" to modify a global variable inside a function!!!
  }
  
  #calculate the distance between the i-th observation and the j-th mean
  calDis <- function(obs_i,mean_j){
    dis <- abs(GL_dataObs[obs_i]-GL_newMeans[mean_j])^2;
    return(dis);
  }
  
  #calculate / update the means
  updateMeans <- function(clusterInd,n,k){
    GL_oldMeans <<- GL_newMeans;
    newMeans_tmp <- rep(0,k);
    clsCNT <- rep(0,k);#obs counts in each cluster
    for(i in 1:n)
    {
      cInd <- clusterInd[i];
      newMeans_tmp[cInd] <- newMeans_tmp[cInd]+GL_dataObs[i];
      clsCNT[cInd] <- clsCNT[cInd]+1;
    }
    GL_newMeans <<- newMeans_tmp/clsCNT;
  }
  
  #calculate diff between oldMean and newMean
  calMeanDiff <- function(){
    diff <- sum(abs(GL_oldMeans-GL_newMeans));
    return(diff);
  }
  
  #calculate the within-point scatter (value of the objective function) manually
  calWPS <- function(clusterInd,n,k){
    WPS <- 0;
    for(i in 1:k){
      clsInd_i <- (clusterInd==i);
      n_i <- sum(clsInd_i);
      dataObs_i <- GL_dataObs[clsInd_i];
      mean_i <- mean(dataObs_i);
      WPS <- WPS + n_i*sum((dataObs_i-mean_i)^2);
    }
    return(WPS);
  }
  
  result_clsInd <- kmeansGeneral(100,2);
  print(result_clsInd);
  print(calWPS(result_clsInd,100,2));
}